function Spinner() {
    this.spinnerElement = null;
    this.spinnerRefCount = 0;
}

Spinner.prototype = {
    initialize: function(id) {
        this.spinnerElement = document.getElementById(id);
    },

    /**
     * Show the spinner while a promise is pending.
     * @param {*} promise is the promise used to start showing and hiding the spinner
     * @returns
     */
    showSpinner: function(promise) {
        this.spinnerRefCount++;
        this.spinnerElement.classList.remove("hide");

        return promise
            .then((v) => {
                this.mayBeHideSpinner();
                return v;
            })
            .catch((v) => {
                this.mayBeHideSpinner();
                throw v;
            });
    },

    /**
     * Hide the spinner if needed
     */
    mayBeHideSpinner: function() {
        if (this.spinnerRefCount > 0) {
            this.spinnerRefCount--;
            if (this.spinnerRefCount == 0) {
                this.spinnerElement.classList.add("hide");
            }
        }
    }
}
